// -*- C++ -*-
// AID-GENERATED
// =========================================================================
// This class was generated by AID - Abstract Interface Definition          
// DO NOT MODIFY, but use the org.freehep.aid.Aid utility to regenerate it. 
// =========================================================================
#ifndef EVENT_SIMTRACKERHIT_H
#define EVENT_SIMTRACKERHIT_H 1

#include "EVENT/LCObject.h"
#include "empty_ignore.h"

namespace EVENT {

class MCParticle;

/** A generic simulated tracker hit. 
 * 
 * @author gaede
 * @version $Id: SimTrackerHit.aid,v 1.7 2005/09/19 15:40:26 gaede Exp $
 */

class SimTrackerHit : public LCObject {

public: 
    /// Destructor.
    virtual ~SimTrackerHit() { /* nop */; }

    /**Returns the detector specific (geometrical) cell id.
     */
    virtual int getCellID() const = 0;

    /** Returns the hit  position in [mm].	
     */
    virtual const double* getPosition() const = 0;

    /** Returns  the dE/dx of the hit in [GeV].
     */ 	
    virtual float getdEdx() const = 0;

    /** Returns the  time of the hit in [ns]. TO DO needs definition.
     */
    virtual float getTime() const = 0;

    /** Returns the MC particle that caused the hit.
     *
     * @see MCParticle
     */
    virtual MCParticle * getMCParticle() const = 0;

    /** Returns the 3-momentum of the particle at the hits position in [GeV] - 
     * optional, only if bit LCIO::THBIT_MOMENTUM is set.	
     */ 
    virtual const float* getMomentum() const = 0;
}; // class
} // namespace EVENT
#endif /* ifndef EVENT_SIMTRACKERHIT_H */
