// -*- C++ -*-
// AID-GENERATED
// =========================================================================
// This class was generated by AID - Abstract Interface Definition          
// DO NOT MODIFY, but use the org.freehep.aid.Aid utility to regenerate it. 
// =========================================================================
#ifndef EVENT_TRACKERHIT_H
#define EVENT_TRACKERHIT_H 1

#include "EVENT/LCObject.h"
#include "LCIOSTLTypes.h"
#include "empty_ignore.h"

namespace EVENT {


class TrackerHit ;
typedef std::vector<TrackerHit*> TrackerHitVec ;
/** A generic tracker hit to be used by pattern recognition.
 * 
 * @author gaede
 * @version $Id: TrackerHit.aid,v 1.8 2004/09/15 13:29:07 gaede Exp $
 */

class TrackerHit : public LCObject {

public: 
    /// Destructor.
    virtual ~TrackerHit() { /* nop */; }

    /** The hit  position in [mm].	
     */
    virtual const double* getPosition() const = 0;

    /**Covariance of the position (x,y,z)
     */
    virtual const FloatVec & getCovMatrix() const = 0;

    /** The dE/dx of the hit in [GeV].
     */ 	
    virtual float getdEdx() const = 0;

    /** The  time of the hit in [ns].
     */
    virtual float getTime() const = 0;

    //     /**Type of raw data hit, either one of<br>
    //      * LCIO::TPCHIT<br>
    //      * LCIO::SIMTRACKERHIT<br>
    //      */
    //    public const String& getType() const ;
    /** Type of hit. Mapping of integer types to type names
     * through collection parameters "TrackerHitTypeNames"
     * and "TrackerHitTypeValues".
     */
    virtual int getType() const = 0;

    /** The raw data hits. 
     * Check getType() to get actual data type.
     */
    virtual const LCObjectVec & getRawHits() const = 0;

//     public void setPosition( double3V pos) ;
//     public void setCovMatrix( const FloatVec& cov) ;
//     public void setdEdx( float dEdx ) ;
//     public void setTime( float time ) ;
//     public void setTPCHit( TPCHit* hit ) ;
}; // class
} // namespace EVENT
#endif /* ifndef EVENT_TRACKERHIT_H */
