// -*- C++ -*-
// AID-GENERATED
// =========================================================================
// This class was generated by AID - Abstract Interface Definition          
// DO NOT MODIFY, but use the org.freehep.aid.Aid utility to regenerate it. 
// =========================================================================
#ifndef IO_LCWRITER_H
#define IO_LCWRITER_H 1

#include <string>

#include "EVENT/LCEvent.h"
#include "EVENT/LCRunHeader.h"
#include "Exceptions.h"

namespace IO {

/**Interface for writing data with LCIO. Uses interfaces 
 * from EVENT/hep.lcio.event.
 * Use LCFactory to instantiate a corresponding LCWriter object
 * for the output format at hand (SIO only, so far).
 *
 * @see LCFactory
 * @author gaede
 * @version Mar 4, 2003
 */
class LCWriter {

public: 
    /// Destructor.
    virtual ~LCWriter() { /* nop */; }

    /** Opens a file for writing. If file with given name exists, 
     * an exception is thrown. Use append or new mode instead.
     *
     *@throws IOException
     */
    virtual void open(const std::string & filename) throw (IOException, std::exception )  = 0;

    /** Opens a file for writing.
     * Possible write modes are: LCIO::WRITE_NEW
     * (existing files are replaced) and LCIO::WRITE_APPEND. 
     *
     *@throws IOException
     */
    virtual void open(const std::string & filename, int writeMode) throw (IOException, std::exception )  = 0;

    /** Writes the given run header to file.
     *
     *@throws IOException
     */
    virtual void writeRunHeader(const EVENT::LCRunHeader * hdr) throw (IOException, std::exception )  = 0;

    /** Writes the given event to file.
     *
     *@throws IOException
     */
    virtual void writeEvent(const EVENT::LCEvent * evt) throw (IOException, std::exception )  = 0;

    /** Closes the output file/stream.
     *
     *@throws IOException
     */
    virtual void close() throw (IOException, std::exception )  = 0;

    /** Flushes the output file/stream.
     *
     *@throws IOException
     */
    virtual void flush() throw (IOException, std::exception )  = 0;
}; // class
} // namespace IO
#endif /* ifndef IO_LCWRITER_H */
