// AID-GENERATED
// =========================================================================
// This class was generated by AID - Abstract Interface Definition          
// DO NOT MODIFY, but use the org.freehep.aid.Aid utility to regenerate it. 
// =========================================================================

package hep.lcio.event;



import hep.lcio.exceptions.* ;
/** The generic collection used in LCIO. Holds arbitrary objects of type LCObject.
 * 
 * @author gaede 
 * @version $Id: LCCollection.aid,v 1.11 2005/03/02 16:22:58 gaede Exp $
 * @see LCObject
 * @see LCIO
 */
           
public interface LCCollection extends java.util.List {

    /**Returns the number of elements in the collection.
     * Same as size().
     */
    public int getNumberOfElements();

    /** Returns the type name of the collection - valid names are defined in LCIO.
     */
    public String getTypeName();

    /** Returns pointer to element at index - no range check, use getNumberOfEntries().
     */
    public LCObject getElementAt(int index);

    /** Returns flag word for collection. Bits 16-31 are reserved for LCIO
     *  Depending on the object type stored they have a special meaning, e.g. 
     *  for SimCalorimeterHits: <br>
     *  CHBIT_LONG = 31   -  store position <br>
     *  CHBIT_BARREL = 30 -  endcap or barrel <br>
     *  CHBIT_ID1 = 29 -   cellid1 is sored <br>
     *  CHBIT_PDG = 28 - store pdg of secondaries <br>
     *  &nbsp;<br>
     *  Bit 16 is used to flag collection as transient <br>
     *  Bit 17 is used to flag collection as default <br>
     *  Bit 18 is used to flag collection as subset <br>
     *  Bits 0-15 are subdetector/user specific.
     * @see isTransient()
     */
    public int getFlag();

    /** True if collection is transient, i.e. will not be written to any LCIO file.
     *  Convenient method that checks bit BITTransient of the flag word.
     */
    public boolean isTransient();

    /** True if collection is the default collection for the given type.
     *  This implies that the collection is complete and unambigous.
     *  Convenient method that checks bit BITDefault of the flag word.
     */
    public boolean isDefault();

    /** True if the collection holds a subset of objects from other collections. 
     *  If the collection is not transient only the pointers/references to the original
     *  objects will be stored.
     *  Convenient method that checks bit BITSubset of the flag word.
     */
    public boolean isSubset();

    /** Adds the given element to (end of) the collection. Throws an exception 
     * if the collection (event) is 'read only'.
     *
     * @throws ReadOnlyException
     */
    public void addElement(LCObject obj) throws ReadOnlyException;

    /** Removes the i-th element from the collection. Throws an exception 
     * if the collection (event) is 'read only'.
     *
     * @throws ReadOnlyException
     */
    public void removeElementAt(int i) throws ReadOnlyException;

    /** Set the flag word. This is allowed in 'read only' mode.
     */
    public void setFlag(int flag);

    /** Parameters defined for this collection.
     */
    public LCParameters getParameters();

    /**Transient bit in flag word.
     */
          
     
                                        
                                        
                                        
      
    public final static int BITTransient = 16;

    public final static int BITDefault = 17;

    public final static int BITSubset = 18;
} // class or interface

